CoyoteOutputStream (Apache Tomcat 8.5.89 API Documentation)

Package org.apache.catalina.connector

## Class CoyoteOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - javax.servlet.ServletOutputStream
    - - org.apache.catalina.connector.CoyoteOutputStream

- All Implemented Interfaces:
    `java.io.Closeable`, `java.io.Flushable`, `java.lang.AutoCloseable`

      public class CoyoteOutputStream
      extends ServletOutputStream

  Coyote implementation of the servlet output stream.
  Author:
    Costin Manolache, Remy Maucherat

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected OutputBuffer` | `ob` |
    `protected static StringManager` | `sm` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `CoyoteOutputStream​(OutputBuffer ob)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected java.lang.Object` | `clone()` | Prevent cloning the facade.
    `void` | `close()` |
    `void` | `flush()` | Will send the buffer to the client.
    `boolean` | `isReady()` | Checks if a non-blocking write will succeed.
    `void` | `setWriteListener​(WriteListener listener)` | Sets the `WriteListener` for this `ServletOutputStream` and thereby switches to non-blocking IO.
    `void` | `write​(byte[] b)` |
    `void` | `write​(byte[] b, int off, int len)` |
    `void` | `write​(int i)` |
    `void` | `write​(java.nio.ByteBuffer from)` |

    - ### Methods inherited from class javax.servlet.ServletOutputStream

      `print, print, print, print, print, print, print, println, println, println, println, println, println, println, println`

    - ### Methods inherited from class java.io.OutputStream

      `nullOutputStream`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sm

          protected static final StringManager sm

    - #### ob

          protected OutputBuffer ob

  - ### Constructor Detail

    - #### CoyoteOutputStream

          protected CoyoteOutputStream​(OutputBuffer ob)

  - ### Method Detail

    - #### clone

          protected java.lang.Object clone()
                                    throws java.lang.CloneNotSupportedException

      Prevent cloning the facade.
      Overrides:
        `clone` in class `java.lang.Object`
      Throws:
        `java.lang.CloneNotSupportedException`

    - #### write

          public void write​(int i)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(byte[] b)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(java.nio.ByteBuffer from)
                     throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Will send the buffer to the client.
      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### isReady

          public boolean isReady()

      Description copied from class: `javax.servlet.ServletOutputStream`
      Checks if a non-blocking write will succeed. If this returns `false`, it will cause a callback to `WriteListener.onWritePossible()` when the buffer has emptied. If this method returns `false` no further data must be written until the container calls `WriteListener.onWritePossible()`.
      Specified by:
        `isReady` in class `ServletOutputStream`
      Returns:
        `true` if data can be written, else `false`

    - #### setWriteListener

          public void setWriteListener​(WriteListener listener)

      Description copied from class: `javax.servlet.ServletOutputStream`
      Sets the `WriteListener` for this `ServletOutputStream` and thereby switches to non-blocking IO. It is only valid to switch to non-blocking IO within async processing or HTTP upgrade processing.
      Specified by:
        `setWriteListener` in class `ServletOutputStream`
      Parameters:
        `listener` - The non-blocking IO write listener